########### abccore.py #####################

import wx
import subprocess
import threading
import os
import re
#import pickle
import wx.html
import wx.stc as stc
from wx.lib.scrolledpanel import ScrolledPanel
from os.path import expanduser
import codecs
#reference https://docs.python.org/2/howto/unicode.html

import g2v.gchord2voice

if wx.Platform == "__WXMSW__":
    abcsettings = {'abc2midi' : 'abc2midi.exe',
    'player': 'C:\Program Files\Windows Media Player\wmplayer.exe',
    'abcm2ps': 'abcm2ps.exe',
    'psrenderer': 'C:\Program Files (x86)\SumatraPDF\SumatraPDF.exe',
    'abc2midipam': '', 'playerpam': '','abcm2pspam' : '',
    'psrendpam': 'Out001.svg',
    'internet' :  'C:\Program Files (x86)\Internet Explorer\iexplore.exe'}
else:
    abcsettings = {'abc2midi' : '../../abc/abc2midi',
    'player': 'timidity', 'abcm2ps' : '../../abc/abcm2ps',
    'psrenderer' : 'firefox', 'abc2midipam' : '-Q 144', 'playerpam' : '-ik',
    'abcm2pspam' : '' , 'psrendpam' : 'Out001.svg', 'internet' : 'firefox'}

abcindex = []


genmidi = [
 '0  Acoustic Grand Piano', '1  Bright Acoustic Piano', '2  Electric Grand Piano',
 '3  Honky-tonk Piano', '4  Electric Piano 1', '5  Electric Piano 2',
 '6  Harpsichord', '7  Clavinet', '8  Celesta', '9  Glockenspiel', '10 Music Box',
 '11 Vibraphone', '12 Marimba', '13 Xylophone', '14 Tubular Bells',
 '15 Dulcimer', '16 Drawbar Organ', '17 Percussive Organ', '18 Rock Organ',
 '19 Church Organ', '20 Reed Organ', '21 Accordion', '22 Harmonica',
 '23 Tango Accordion', '24 Acoustic Guitar (nylon)',
 '25 Acoustic Guitar (steel)', '26 Electric Guitar (jazz)',
 '27 Electric Guitar (clean)', '28 Electric Guitar (muted)',
 '29 Overdriven Guitar', '30 Distortion Guitar', '31 Guitar harmonics',
 '32 Acoustic Bass', '33 Electric Bass (finger)', '34 Electric Bass (pick)',
 '35 Fretless Bass', '36 Slap Bass 1', '37 Slap Bass 2', '38 Synth Bass 1',
 '39 Synth Bass 2', '40 Violin', '41 Viola', '42 Cello', '43 Contrabass',
 '44 Tremolo Strings', '45 Pizzicato Strings', '46 Orchestral Harp',
 '47 Timpani', '48 String Ensemble 1', '49 String Ensemble 2',
 '50 Synth Strings 1', '51 Synth Strings 2', '52 Choir Aahs',
 '53 Voice Oohs', '54 Synth Voice', '55 Orchestra Hit', '56 Trumpet',
 '57 Trombone', '58 Tuba', '59 Muted Trumpet', '60 French Horn',
 '61 Brass Section', '62 Synth Brass 1', '63 Synth Brass 2',
 '64 Soprano Sax', '65 Alto Sax', '66 Tenor Sax', '67 Baritone Sax',
 '68 Oboe', '69 English Horn', '70 Bassoon', '71 Clarinet', '72 Piccolo',
 '73 Flute', '74 Recorder', '75 Pan Flute', '76 Blown Bottle', '77 Shakuhachi',
 '78 Whistle', '79 Ocarina', '80 Lead 1 (square)', '81 Lead 2 (sawtooth)',
 '82 Lead 3 (calliope)', '83 Lead 4 (chiff)', '84 Lead 5 (charang)',
 '85 Lead 6 (voice)', '86 Lead 7 (fifths)', '87 Lead 8 (bass + lead)',
 '88 Pad 1 (new age)', '89 Pad 2 (warm)', '90 Pad 3 (polysynth)',
 '91 Pad 4 (choir)', '92 Pad 5 (bowed)', '93 Pad 6 (metallic)',
 '94 Pad 7 (halo)', '95 Pad 8 (sweep)', '96 FX 1 (rain)',
 '97 FX 2 (soundtrack)', '98 FX 3 (crystal)', '99 FX 4 (atmosphere)',
 '100 FX 5 (brightness)', '101 FX 6 (goblins)', '102 FX 7 (echoes)',
 '103 FX 8 (sci-fi)', '104 Sitar', '105 Banjo', '106 Shamisen', '107 Koto',
 '108 Kalimba', '109 Bag pipe', '110 Fiddle', '111 Shanai', '112 Tinkle Bell',
 '113 Agogo', '114 Steel Drums', '115 Woodblock', '116 Taiko Drum',
 '117 Melodic Tom', '118 Synth Drum', '119 Reverse Cymbal',
 '120 Guitar Fret Noise', '121 Breath Noise', '122 Seashore',
 '123 Bird Tweet', '124 Telephone Ring', '125 Helicopter', '126 Applause',
 '127 Gunshot']
octaveshift = ['-2', '-1', '0', '1', '2']


path = 'test.abc'
outputmsg = ''
abcedit = None
tocselection = -1 

def str2bool(v):
   ''' converts a string to a boolean if necessary'''
   if type(v) == str:
       return v.lower() in ('yes', 'true', 't' ,'1')
   else:
       return v

def initialize_settings():
    ''' initial settings the first time the program is run'''
    abcsettings['melprog'] = '0'
    abcsettings['melvol'] = '100'
    abcsettings['chordprog'] = '24'
    abcsettings['chordvol'] = '72'
    abcsettings['chordoct'] = '0'
    abcsettings['bassprog'] = '32'
    abcsettings['bassvol'] = '84'
    abcsettings['bassoct'] = '0'
    abcsettings['doubprog'] = '71'
    abcsettings['doubvol'] = '100'
    abcsettings['douboct'] = '1'
    abcsettings['doubchk'] = 'False'
    abcsettings['gchord'] = 'default'
    abcsettings['drum'] = 'none'
    abcsettings['openfile'] = None
    abcsettings['tempo'] = '160'
    abcsettings['ignoreQ'] = 'False'
    abcsettings['ignoreMIDI'] = 'False'
    abcsettings['apitch'] = 440
    abcsettings['midi2NFNP'] = 'False'
    abcsettings['midi2NFER'] = 'False'
    abcsettings['midi2NGRA'] = 'False'
    abcsettings['midi2BF']   = 'False'
    abcsettings['midi2RS']   = 'False'
    abcsettings['psrefno']   = 'False'
    abcsettings['psbarno']   = 'False'
    abcsettings['pslines']   = 'False'
    abcsettings['pslyric']   = 'False'
    abcsettings['pslands']   = 'False'
    abcsettings['psflatb']   = 'False'
    abcsettings['psembed']   = 'False'
    abcsettings['pssvg']     = 'False'
    abcsettings['psscale']   = '0.90'
    abcsettings['pswidth']   = '600'
    abcsettings['pslmarg']   = '50'
    abcsettings['psstaff']   = '20'
    abcsettings['searchfolder']    = '.'
    abcsettings['vvol'] =  str(['96']*16)
    abcsettings['vbal'] =  str(['64']*16)
    abcsettings['vprog'] = str(['0 Acoustic Piano']*16)



def update_abc2midipam():
    '''updates the parameter list for abc2midi based on the
    abcsettings.
    '''
    global abcsettings
    abc2midipam = ''
    if str2bool(abcsettings['midi2NFNP']) == True:
        abc2midipam = abc2midipam + ' -NFNP'
    if str2bool(abcsettings['midi2NFER']) == True:
        abc2midipam = abc2midipam + ' -NFER'
    if str2bool(abcsettings['midi2NGRA']) == True:
        abc2midipam = abc2midipam + ' -NGRA'
    if str2bool(abcsettings['midi2BF'])  == True:
        abc2midipam = abc2midipam + ' -BF'
    if str2bool(abcsettings['midi2RS']) == True:
        abc2midipam = abc2midipam + ' -RS'
    if int(abcsettings['apitch']) != 440:
        abc2midipam = abc2midipam + ' -TT '+str(abcsettings['apitch'])
    abcsettings['abc2midipam'] = abc2midipam
 

def update_abcm2pspam():
    '''updates the parameter list for abcm2ps based on the abcsettings'''
    global abcsettings
    abcm2pspam = ''
    if abcsettings['psembed'] == True:
        abcsettings['abcm2pspam'] = abcm2pspam
        return    
    if str2bool(abcsettings['psrefno']) == True:
        abcm2pspam = abcm2pspam + ' -x'
    if str2bool(abcsettings['psbarno']) == True:
        abcm2pspam = abcm2pspam + ' -j 1'
    if str2bool(abcsettings['pslines']) == True:
        abcm2pspam = abcm2pspam + ' -c'
    if str2bool(abcsettings['pslyric']) == True:
        abcm2pspam = abcm2pspam + ' -M'
    if str2bool(abcsettings['pslands']) == True:
        abcm2pspam = abcm2pspam + ' -l'
    if str2bool(abcsettings['psflatb']) == True:
        abcm2pspam = abcm2pspam + ' -f'
    if str2bool(abcsettings['pssvg']) == True:
        abcm2pspam = abcm2pspam + ' -g'
    abcsettings['abcm2pspam'] = abcm2pspam
    abcm2pspam = abcm2pspam + ' -s ' + abcsettings['psscale']
    abcm2pspam = abcm2pspam + ' -w ' + abcsettings['pswidth']
    abcm2pspam = abcm2pspam + ' -m ' + abcsettings['pslmarg']
    abcm2pspam = abcm2pspam + ' -d ' + abcsettings['psstaff'] 
    abcsettings['abcm2pspam'] = abcm2pspam
    settings.filesettings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])


def save_settings():
    '''Cache away the abcsettings in the file abccore.ini.
     I do not to use pickle to save and load the settings,so
    that not all the default settings get wiped out when I load
    the settings and I have some control on what is saved.
    '''
    abcsettings['gchord'] = 'default'
    abcsettings['drum'] = 'none'
    f = open('abccore.ini','w')
    for key in sorted(abcsettings):
        #print key + '=>' + abcsettings[key]
        f.write(key)
        f.write('=')
        f.write(str(abcsettings[key]))
        f.write('\n')
    f.close()


def load_settings(abcsettingkeys):
    ''' load abcsettings from the file abccore.ini'''
    for line in open('abccore.ini'):
        line = line.rstrip()
        #print line
        index = line.find('=')
        key = line[0:index]
        # do not keep unknown keys
        if abcsettingskeys.index(key) != -1:
            value = line[index+1:]
            abcsettings[key] = value


def toc(path):
  ''' Reads an abc file found in 'path' and returns a list of
  of all tunes and their position in that files. The
  list is eventually stored in the global abcindex. We check
  for the possibility of a key change, (i.e. more than one K:
  in the the tune).
  '''
  global file
  file = open(path,'rb')
  pos = 0
  line = file.readline()
  tocindex = []

  title = ''
  while line != None:
     if not line:
       break
     #print line,line.find('X:'),file.tell()
     if line.find('X:') == 0:
       filepos = pos
       xref = int(line[2:])
       kfound = 0
       #print file.tell()
     elif line.find('T:') == 0:
       sline = line.rstrip()
       title = sline[2:]
     elif line.find('K:') == 0:
       sline = line.rstrip()
       keysig = sline[2:]
       if kfound == 0:
           tocindex.append([xref, keysig, title, filepos])
       kfound = 1
     else:
       pos = file.tell() 
     line = file.readline()

  file.close()
  return tocindex


def extract_toc_entry (i,abcindex):
    ''''extract the selected tune from the abc file which may contain
    a collection of tunes.'''
    global abcedit
    file = open(abcsettings['openfile'],'rb')
#   open as a binary file so we get the right number of bytes
#   on Linux on  Windows PC
    entry1 = abcindex[i]
    loc1   = entry1[3]
    file.seek(loc1)
    if i < len(abcindex)-1:
      entry2 = abcindex[i+1]
      loc2 =entry2[3]
      abc = file.read(loc2-loc1)
    else:
      size = os.path.getsize(abcsettings['openfile'])
      abc = file.read(size-loc1) 
    file.close()
    abc = abc.decode('latin1')
    abcedit.ShowText(abc)
    return abc


def update_source_abc_file (abc):
    ''' replaces a specific tune in an abc file with
        the contents of the editor window. '''
    global abcedit
    global tocselection
    # find position of the extracted tune in the source file
    i = tocselection
    entry1 = abcindex[i]
    entry2 = abcindex[i+1]
    loc1   = entry1[3]
    loc2 =entry2[3]
    fileout = codecs.open('X.tmp','wb',encoding='latin1')
    # copy everything before this tune
    filein = codecs.open(abcsettings['openfile'],'rb',encoding='latin1')
    filein.seek(0)
    data = filein.read(loc1)
    fileout.write(data)
    # paste the contents of the editor window
    fileout.write(abc)
    # copy everything after this tune
    filein.seek(loc2)
    size = os.path.getsize(abcsettings['openfile'])
    data = filein.read(size-loc2)
    fileout.write(data)
    filein.close()
    fileout.close()

    # back up the original file by renaming it
    # and rename the temp file to the original name
    newname = abcsettings['openfile']+'.bak'
    os.rename(abcsettings['openfile'],newname)
    os.rename('X.tmp',abcsettings['openfile'])
    refresh_tocdatabase()


def refresh_tocdatabase():
    global abcindex
    abcindex = toc(abcsettings['openfile'])
    top.list_ctrl.add_toc_database(abcindex)



def create_tmp_for_abcm2ps (abc):
    ''' creates the file X.tmp with all the abcm2ps directives
    if needed'''
    header = make_abcm2ps_header()
    abc = insert_ps_header(abc,header)
    abcedit.ShowText(abc)
    write_abc_file('X.tmp',abc)


def make_midi_header():
    ''' creates the set of %%MIDI commands to be included in the X.tmp file
    after the K: field command'''
    global genmidi
    l = []
    l1 = '%%MIDI program '+abcsettings['melprog']
    p  = genmidi[int(abcsettings['melprog'])]
    l1 = l1 + " " + p[3:] 
    l.append(l1)
    l2 = '%%MIDI bassprog '+abcsettings['bassprog']+' octave='+abcsettings['bassoct'] 
    p  = genmidi[int(abcsettings['bassprog'])]
    l2 = l2 + ' ' + p[3:]
    l.append(l2)
    l3 = '%%MIDI chordprog '+abcsettings['chordprog']+ ' octave='+abcsettings['chordoct'] 
    p  = genmidi[int(abcsettings['chordprog'])]
    l3 = l3 + ' ' + p[3:]
    l.append(l3)
    l.append('%%MIDI bassvol '+abcsettings['bassvol'])
    l.append('%%MIDI chordvol '+abcsettings['chordvol'])
    m  = int(abcsettings['melvol'])
    m2 = m - 10
    m3 = m - 20
    if m2 < 0:
        m2 = 0
    if m3 < 0:
        m3 = 0
    l.append('%%MIDI beat '+ str(abcsettings['melvol']) +' ' + str(m2) + ' ' + str(m3) + ' 4')
    if abcsettings['gchord'] != 'default':
        l.append('%%MIDI gchord '+abcsettings['gchord'])
    if abcsettings['drum'] != 'none':
        l.append('%%MIDI drum ' + abcsettings['drum'])
        l.append('%%MIDI drumon')
    l.append('Q: 1/4= ' + str(abcsettings['tempo']))
    return l


def make_abcm2ps_header():
    ''' creates a block of abcm2ps directives to be inserted in the X.tmp file'''
    global abcsettings
    ps_directives = ''
    if str2bool(abcsettings['psrefno']) == True:
        ps_directives = ps_directives + '%% writefields X\n'
    if str2bool(abcsettings['psbarno']) == True:
        ps_directives = ps_directives + '%% measurenb 1\n'
    if str2bool(abcsettings['pslines']) == True:
        ps_directives = ps_directives + '%% linebreak <none>\n'
    if str2bool(abcsettings['pslyric']) == True:
        ps_directives = ps_directives + '%% musiconly 1\n'
    if str2bool(abcsettings['pslands']) == True:
        ps_directives = ps_directives + '%% landscape 1\n'
    if str2bool(abcsettings['psflatb']) == True:
        ps_directives = ps_directives + '%% flat beams 1\n'
    if str2bool(abcsettings['pssvg']) == True:
        ps_directives = ps_directives + '%% svg 1\n'
    ps_directives = ps_directives + '%% scale ' + abcsettings['psscale'] +'\n'
    ps_directives = ps_directives + '%% staffwidth ' + abcsettings['pswidth'] +'\n'
    ps_directives = ps_directives + '%% left margin ' + abcsettings['pslmarg'] + '\n'
    ps_directives = ps_directives + '%% staffsep ' + abcsettings['psstaff'] + '\n'
    return ps_directives


def strip_out_guitarchords (abc):
    ''' removes all guitar chords (anything in between pairs of double quotes as
    well as the double quotes'''
    gchordpat = re.compile('\"[^\"]+\"')
    abc = re.sub(gchordpat,'',abc)
    return abc


def remove_some_MIDI_commands(abc):
    ''' removes the %%MIDI commands which contain program, bassprog, chordprog,
    bassvol, chordvol, control, and beat in the abc tune so that they can be replaced by
    the information in the midi_header block.'''
    abcout = ''
    for line in abc.split('\n'):
        if line.find('%%MIDI') == 0:
            if line.find('program') > 0 or line.find('chordprog') > 0 or line.find('bassprog') > 0:
                continue
            if line.find('bassvol') >0 or line.find('chordvol') >0 or line.find('beat') > 0:
                continue
            if line.find('control') >0 :
                continue
        abcout = abcout+line+'\n'
    return abcout


def remove_all_MIDI_commands(abc):
    abcout = ''
    for line in abc.split('\n'):
        if line.find('%%MIDI') == 0:
            continue
        abcout = abcout+line+'\n'
    return abcout


def remove_Q_commands(abc):
    ''' removes the tempo command that may be embedded in the tune'''
    abcout = ''
    for line in abc.split('\n'):
        if line.find('Q:') == 0:
            continue
        abcout = abcout+line+'\n'
    return abcout


def remove_all_ps_commands(abc):
    abcout = ''
    for line in abc.split('\n'):
        if line.find('%%') == 0:
            continue
        abcout = abcout+line+'\n'
    return abcout


def has_voices (abc):
    if abc.find('V:') > 0:
        return True
    return False

def create_tmp_for_abc2midi (abc):
    ''' creates the X.tmp file which is the input to abc2midi'''
    header = make_midi_header()
    if str2bool(abcsettings['ignoreMIDI']) == True:
        abc = remove_some_MIDI_commands(abc)
    if str2bool(abcsettings['ignoreQ']) == True:
        abc = remove_Q_commands(abc)
    abc = insert_midi_header(abc,header)

    voices = has_voices(abc)

    if str2bool(abcsettings['doubchk']) == True and voices == False:
        abc = create_double_abc2midi (abc)

    if voices == True:
        abc = insert_voice_midi_controls(abc)

    abcedit.ShowText(abc)
    write_abc_file('X.tmp',abc)




def create_double_abc2midi (abc):
    '''creates the X.tmp file for abc2midi when the main voice is doubled'''
    # search for the body and save
    global genmidi
    inbody = False
    body = ''
    abcout = ''
    for line in abc.split('\n'):
        if len(line) < 2:
            continue
        abcout = abcout+line+'\n'
        if line.find('K:') == 0 and inbody == False:
            inbody = True
            abcout = abcout + 'V:1\n'
            continue
        if inbody == True:
            body = body + line+'\n'
        body = strip_out_guitarchords(body)
    abcout = abcout + 'V:2'
    abcout = abcout + ' octave=' + abcsettings['douboct'] + '\n'
    abcout = abcout + '%%MIDI program '+abcsettings['doubprog'] 
    p  = genmidi[int(abcsettings['doubprog'])]
    abcout = abcout + ' ' + p[3:] +'\n'
    abcout =  abcout + body
    return abcout




def insert_midi_header(abc,header):
    ''' pastes the midi commands into the tune immediately after the
    first K: command'''
    abcout = ''
    for line in abc.split('\n'):
        abcout = abcout+line+'\n'
        if line.find('K:') == 0:
            for item in header:
                abcout = abcout+item+'\n'
    return abcout


def insert_voice_midi_controls(abc):
    global abcsettings
    vprog = eval(abcsettings['vprog'])
    vvol  = eval(abcsettings['vvol'])
    vbal  = eval(abcsettings['vbal'])
    abcout = ''
    voicemapper = {}
    for line in abc.split('\n'):
        abcout = abcout+line+'\n'
        if line.find('V:') == 0:
            line = line[2:-1]
            lline  = line.split() 
            n = lline[0]
            if voicemapper.get(n) == None:
               voicemapper[n] = n
               abcout = abcout + '%%MIDI program {0}\n'.format(vprog[int(n)])
               abcout = abcout + '%%MIDI control 7 {0}\n'.format(vvol[int(n)])
               abcout = abcout + '%%MIDI control 10 {0}\n'.format(vbal[int(n)])
    return abcout


def insert_ps_header(abc,header):
    ''' pastes the abcm2ps directives into the tune immediately after
    the X: reference command'''
    abcout = ''
    for line in abc.split('\n'):
        abcout = abcout+line+'\n'
        if line.find('X:') == 0:
            abcout = abcout+header
    return abcout


def write_Xtmp (abc):
    '''writes or overwrites the X.tmp file'''
    filex = open('X.tmp','wb')
    filex.write(abc)
    filex.close
    return abc


def write_abc_file (path,abc):
    '''write or overwrite file path with abc'''
    filex = codecs.open(path,'wb',encoding='utf-8')
    filex.write(abc)
    filex.close


def run_abc2midi (self):
    '''verifies that the abc2midi program exists and then run abc2midi catching any run time
    errors and warnings. If the messages info box is displayed, update its contents.'''
    global outputmsg
    if os.path.exists(abcsettings['abc2midi']) == False:
        msg = 'abc2midi was not found at ' + abcsettings['abc2midi'] + ' Go to settings and indicate the path'
        dlg = wx.MessageDialog(self,msg, 'Warning',wx.OK)
        dlg.ShowModal()
    else:
        c = [abcsettings['abc2midi'] , 'X.tmp', '-o', 'X.mid']
        d = abcsettings['abc2midipam'].split()
        c = c + d
        #outputmsg = subprocess.check_output(c)
        process = subprocess.Popen(c, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE, creationflags = 0, universal_newlines=True)  
        stdout_value, stderr_value = process.communicate(input=None)
        outputmsg = stdout_value + stderr_value
        f = ' '
        if outputmsg.find('Error') != -1:
            self.UpdateStatusBar('Abc2midi reported some errors')
        if outputmsg.find('Warning') != -1:
            self.UpdateStatusBar('Abc2midi reported some warnings')

        f = ' '
        e = f.join(c)
        outputmsg = e + '\n' + outputmsg
        win = wx.FindWindowByName('infoframe')
        if win != None:
            win.ShowText(outputmsg)
            


def run_abcm2ps (self):
    '''verifies that the abcm2ps program exists and then run abcm2ps catching any run time
    errors and warnings. If the messages info box is displayed, update its contents.'''
    global outputmsg
    outputmsg = ''
    if os.path.exists(abcsettings['abcm2ps']) == False:
        dlg = wx.MessageDialog(self,'abcm2ps was not found here. Go to settings and indicate the path','Warning',wx.OK)
        dlg.ShowModal()
    else:
        c = [abcsettings['abcm2ps'],'X.tmp']
        #c = c + ' X.tmp'
        d = abcsettings['abcm2pspam']
        c = c + d.split()
    process = subprocess.Popen(c, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE, creationflags = 0, universal_newlines=True)  
    stdout_value, stderr_value = process.communicate(input=None)
    outputmsg = stdout_value + stderr_value
    f = ' '
    e = f.join(c)
    outputmsg = e + '\n' + outputmsg
    if outputmsg.find('Error') != -1:
        self.UpdateStatusBar('Abcm2ps reported some errors')
    if outputmsg.find('Warning') != -1:
        self.UpdateStatusBar('Abcm2ps reported some warnings')
    win = wx.FindWindowByName('infoframe')
    if win != None:
        win.ShowText(outputmsg)



def start_midi_out ():
    ''' Starts the Midi Player which runs as a separate thread in order not to
    hang up this program
    '''
    playmusicthread = MidiThread()
    

def start_display_out (self):
    ''' Starts the PostScript program as a separate thread'''
    psrendererpath = abcsettings['psrenderer']
    if os.path.exists(psrendererpath) == False:
        dlg = wx.MessageDialog(self,'psrenderer was not found here. Go to settings and indicate the path','Warning',wx.OK)
        dlg.ShowModal()
        return
    displaythread = PsThread()



def play_midi ():
    ''' called by MidiThread'''
    midifile = os.path.join(os.getcwd(),'X.mid')
    c = [abcsettings['player'],  midifile,abcsettings['playerpam']]
    output = subprocess.check_output(c)


def display_Out ():
    ''' called by PsThread() '''
    global outputmsg
    if abcsettings['pssvg'] == 'False':
        a = abcsettings['psrenderer']
        d = 'Out.ps'
        outfile = os.path.join(os.getcwd(),d)
    else:
        a = abcsettings['internet'] 
        d = 'Out001.svg'
        outfile = os.path.join('file:///',os.getcwd(),d)
 
    c = [a , outfile]

    process = subprocess.Popen(c, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE, creationflags = 0, universal_newlines=True)  
    stdout_value, stderr_value = process.communicate(input=None)



class MidiThread(threading.Thread):
    ''' This is how python runs a separate thread'''
    def __init__ (self):
        threading.Thread.__init__(self)
        self.start()

    def run(self):
        play_midi()
 

class PsThread(threading.Thread):
    ''' This is how python runs a separate thread'''
    def __init__ (self):
        threading.Thread.__init__(self)
        self.start()

    def run(self):
        display_Out()
 


def find_abc_files(root):
    ''' Does a recursive search of all folders inside root for abc files
        storing the results in the list abcmatches. Pops up a progress
        bar and searches each abc file in abcmatches for a specific
        searchstring in the title field by calling search_for_abc_string.'''
    # adapted from Programming Python by Mark Lutz
    abcmatches = []
    for (dirname,dirshere,fileshere) in os.walk(root):
        #print fileshere
        searchstring = top.search.searchstring.GetValue()
        searchstring = searchstring.lower()
        #print searchstring
        for filename in fileshere:
            if filename.endswith('.abc') or filename.endswith('.ABC'):
                pathname = os.path.join(dirname,filename)
                abcmatches.append(pathname)

    progmax = len(abcmatches)
    progdialog = wx.ProgressDialog('Searching directory','Remaining time',
                 progmax,style = wx.PD_CAN_ABORT | wx.PD_ELAPSED_TIME |
                 wx.PD_REMAINING_TIME | wx.PD_AUTO_HIDE)
    #for name in abcmatches: print name
    k = 0
    for pathname in abcmatches:
        #print str(k) + ' ' + pathname
        k = k+1
        top.search.running = progdialog.Update(k)       
        search_for_abc_string(pathname,'T:',searchstring)
        if top.search.running[0] == False or k > progmax:
            break

    progdialog.Destroy()



def search_for_abc_string (path, abckey, searchstring):
    ''' searches abc file pointed to by path in the field command
        abckey for the string searchstring. If the string is found,
        append the field command to the listbox containing the
        search results.
    '''
    loc = -1
    lastloc = loc
    #print path
    for line in open(path): 
        if top.search.running == 0:
            break
        line = line.decode('latin1')
        searchstring = searchstring.decode('latin1')
        if line.find('X:') == 0:
            ref = line[2:]
            ref = ref.rstrip()
            loc = loc + 1
        if line.find(abckey) == 0:
            line = line.rstrip()
            #try:
                #print str(ref) + '\t' + str(loc) +'\t' +str(lastloc) + '\t' + line[2:]
            #except:
                #print str(ref) + '\t' + str(loc) + '\t' +str(lastloc)
            lline = line.lower()
            if lline.find(searchstring) > 0 and loc != lastloc:
                top.search.list_ctrl.InsertStringItem(top.search.count,line[2:])
                top.search.searchpaths[top.search.count] = path
                top.search.searchlocator[top.search.count] = loc
                #print str(top.search.count) + ' ' + path + ' ' + str(loc)
                top.search.count = top.search.count + 1
            lastloc = loc





################################################
########## wxPython User Interface #############
################################################




class MyToc(wx.Panel):
    ''' sets up the wx.ListCtrl for displaying the list of tunes in
    a abc file which contains a collection of tunes'''
    def __init__(self,parent):
        wx.Panel.__init__(self,parent,id=wx.ID_ANY)
        self.list_ctrl = wx.ListCtrl(self, size=(360,320),
                         style=wx.LC_REPORT |wx.BORDER_SUNKEN|wx.LC_SINGLE_SEL)
        self.list_ctrl.InsertColumn(0, 'Xref', width=50)
        self.list_ctrl.InsertColumn(1, 'Key signature',width = 90)
        self.list_ctrl.InsertColumn(2, 'Title', width = 220)
        self.list_ctrl.Bind(wx.EVT_LIST_ITEM_SELECTED,self.OnItemSelected,self.list_ctrl)


    def add_toc_database(self, abcindex):
        ''' abcindex is a list of the Xref numbers, key signature and
        titles of all the tunes in the abc file. The method replaces the
        contents of the listbox with this list.'''
        self.list_ctrl.DeleteAllItems()
        i = 0
        for entry in abcindex:
           x = str(entry[0])
           t = entry[1]
           p = str(entry[2])
           p = p.decode('latin1')
           if len(entry) > 1:
               self.list_ctrl.InsertStringItem(i, x)
               self.list_ctrl.SetStringItem(i, 1, t)
               self.list_ctrl.SetStringItem(i, 2, p)
               i += 1


    def OnItemSelected(self, evt):
        ''' When you select a tune in the wx.ListCtrl, the
        global abc contains the contents of the selected tune'''
        global abc
        global tocselection
        tocselection = evt.GetIndex()
        abc = extract_toc_entry(tocselection,abcindex)
      


class MyFileSettings(wx.Panel):
    ''' This is one of several panels in the Settings notebook.
    This panel sets up the paths to all the external executables
    which this program requires. All of these paths are stored
    in the abcsettings python dictionary.'''
    def __init__(self,parent):
        wx.Panel.__init__(self, parent)
        # Add a panel so it looks the correct on all platforms
        gridsizer   = wx.FlexGridSizer(9,3,2,2)
        abc2midilab = wx.StaticText(self,-1,"path to abc2midi")
        self.abc2miditxt = wx.TextCtrl(self,-1,abcsettings['abc2midi'],(-1,-1),(200,-1))
        self.abc2midibut = wx.Button(self,-1,'Browse')

        playerlab   = wx.StaticText(self,-1,"path to midi player")
        self.playertxt   = wx.TextCtrl(self,-1,abcsettings['player'],(-1,-1),(200,-1))
        self.playerbut   = wx.Button(self,-1,'Browse')

        abcm2pslab  = wx.StaticText(self,-1,"path to abcm2ps")
        self.abcm2pstxt  = wx.TextCtrl(self,-1,abcsettings['abcm2ps'],(-1,-1),(200,-1))
        self.abcm2psbut  = wx.Button(self,-1,'Browse')

        psrendlab   = wx.StaticText(self,-1,"path to PS renderer")
        self.psrendtxt   = wx.TextCtrl(self,-1,abcsettings['psrenderer'],(-1,-1),(200,-1))
        self.psrendbut   = wx.Button(self,-1,'Browse')

        internetlab = wx.StaticText(self,-1,"path to internet browser")
        self.internettxt = wx.TextCtrl(self,-1,abcsettings['internet'], (-1,-1),(200,-1))
        self.internetbut = wx.Button(self,-1,'Browse')


        abc2midipamlab   = wx.StaticText(self,-1,"abc2midi parameters")
        self.abc2midipamtxt = wx.TextCtrl(self,-1,abcsettings['abc2midipam'], (-1,-1),(200,-1),style = wx.TE_READONLY)

        playerpamlab     = wx.StaticText(self,-1,'midi player parameters')
        self.playerpamtxt     = wx.TextCtrl(self,-1,abcsettings['playerpam'],
[-1,-1],(200,-1))

        abcm2pspamlab    = wx.StaticText(self,-1,'abcm2ps parameters')
        self.abcm2pspamtxt    = wx.TextCtrl(self,-1,abcsettings['abcm2pspam'],
[-1,-1],(200,-1))

        psrendpamlab     = wx.StaticText(self,-1,'PS renderer parameters')
        self.psrendpamtxt     = wx.TextCtrl(self,-1,abcsettings['psrendpam'],
[-1,-1],(200,-1))


        gridsizer.Add(abc2midilab,0,0,0)     
        gridsizer.Add(self.abc2miditxt,0,0)     
        gridsizer.Add(self.abc2midibut,0,0,0)     

        gridsizer.Add(playerlab,0,0,0)
        gridsizer.Add(self.playertxt,0,0,0)
        gridsizer.Add(self.playerbut,0,0,0)

        gridsizer.Add(abcm2pslab,0,0,0)
        gridsizer.Add(self.abcm2pstxt,0,0,0)
        gridsizer.Add(self.abcm2psbut,0,0,0)

        gridsizer.Add(psrendlab,0,0,0)
        gridsizer.Add(self.psrendtxt,0,0,0)
        gridsizer.Add(self.psrendbut,0,0,0)

        gridsizer.Add(internetlab,0,0,0)
        gridsizer.Add(self.internettxt,0,0,0)
        gridsizer.Add(self.internetbut,0,0,0)

        gridsizer.Add(abc2midipamlab,0,0,0)
        gridsizer.Add(self.abc2midipamtxt,0,0,0)
        gridsizer.Add(wx.Size(-1,-1),0,0,0)

        gridsizer.Add(playerpamlab,0,0,0)
        gridsizer.Add(self.playerpamtxt,0,0,0)
        gridsizer.Add(wx.Size(-1,-1),0,0,0)

        gridsizer.Add(abcm2pspamlab,0,0,0)
        gridsizer.Add(self.abcm2pspamtxt,0,0,0)
        gridsizer.Add(wx.Size(-1,-1),0,0,0)

        gridsizer.Add(psrendpamlab,0,0,0)
        gridsizer.Add(self.psrendpamtxt,0,0,0)
        gridsizer.Add(wx.Size(-1,-1),0,0,0)

        gridsizer.Fit(self)

        self.Bind(wx.EVT_TEXT,self.On_abc2midi_txt,self.abc2miditxt)
        self.Bind(wx.EVT_TEXT,self.On_player_txt,self.playertxt)
        self.Bind(wx.EVT_TEXT,self.On_abcm2ps_txt,self.abcm2pstxt)
        self.Bind(wx.EVT_TEXT,self.On_psrend_txt,self.psrendtxt)
        self.Bind(wx.EVT_TEXT,self.On_abc2midipam_txt,self.abc2midipamtxt)
        self.Bind(wx.EVT_TEXT,self.On_playerpam_txt,self.playerpamtxt)
        self.Bind(wx.EVT_TEXT,self.On_abcm2pspam_txt,self.abcm2pspamtxt)
        self.Bind(wx.EVT_TEXT,self.On_psrendpam_txt,self.psrendpamtxt)
        self.Bind(wx.EVT_TEXT,self.On_internet_txt,self.internettxt)
        self.Bind(wx.EVT_BUTTON,self.On_browse_abc2midi,self.abc2midibut)
        self.Bind(wx.EVT_BUTTON,self.On_browse_player,self.playerbut)
        self.Bind(wx.EVT_BUTTON,self.On_browse_abcm2ps,self.abcm2psbut)
        self.Bind(wx.EVT_BUTTON,self.On_browse_psrend,self.psrendbut)
        self.Bind(wx.EVT_BUTTON,self.On_browse_internet,self.internetbut)
        self.SetSizer(gridsizer)
        self.Fit()
        self.Layout()

    def On_abc2midi_txt(self,evt):
        abcsettings['abc2midi'] = self.abc2miditxt.GetValue()
        
    def On_player_txt(self,evt):
        abcsettings['player'] = self.playertxt.GetValue()

    def On_abcm2ps_txt(self,evt):
        abcsettings['abcm2ps'] = self.abcm2pstxt.GetValue()

    def On_psrend_txt(self,evt):
        abcsettings['psrenderer'] = self.psrendtxt.GetValue()

    def On_abc2midipam_txt(self,evt):
        abcsettings['abc2midipam'] = self.abc2midipamtxt.GetValue()

    def On_playerpam_txt(self,evt):
        abcsettings['playerpam'] = self.playerpamtxt.GetValue()

    def On_abcm2pspam_txt(self,evt):
        abcsettings['abcm2pspam'] = self.abcm2pspamtxt.GetValue() 

    def On_psrendpam_txt(self,evt):
        abcsettings['psrendpam'] = self.psrendpamtxt.GetValue()

    def On_internet_txt(self,evt):
        abcsettings['internet'] = self.internettxt.GetValue()


    def On_browse_abc2midi(self,evt):
        #dlg = wx.FileDialog(self,"Open","","","executable files|*",wx.OPEN)
        dlg = wx.FileDialog(self,"Open","","","*",wx.OPEN)
        if dlg.ShowModal() == wx.ID_OK:
           abcsettings['abc2midi'] = dlg.GetPath()
           self.abc2miditxt.SetValue(abcsettings['abc2midi'])
        dlg.Destroy()

    def On_browse_player(self,evt):
        dlg = wx.FileDialog(self,"Open","","","executable files|*",wx.OPEN)
        if dlg.ShowModal() == wx.ID_OK:
           abcsettings['player'] = dlg.GetPath()
           self.playertxt.SetValue(abcsettings['player'])
        dlg.Destroy()

    def On_browse_abcm2ps(self,evt):
        dlg = wx.FileDialog(self,"Open","","","executable files|*",wx.OPEN)
        if dlg.ShowModal() == wx.ID_OK:
           abcsettings['abcm2ps'] = dlg.GetPath()
           self.abcm2pstxt.SetValue(abcsettings['abcm2ps'])
        dlg.Destroy()

    def On_browse_psrend(self,evt):
        dlg = wx.FileDialog(self,"Open","","","executable files|*",wx.OPEN)
        if dlg.ShowModal() == wx.ID_OK:
           abcsettings['psrenderer'] = dlg.GetPath()
           self.psrendtxt.SetValue(abcsettings['psrenderer'])
        dlg.Destroy()

    def On_browse_internet(self,evt):
        dlg = wx.FileDialog(self,"Open","","","executable files|*",wx.OPEN)
        if dlg.ShowModal() == wx.ID_OK:
           abcsettings['internet'] = dlg.GetPath()
           self.internettxt.SetValue(abcsettings['internet'])
        dlg.Destroy()


class MyAbc2midiSettings(wx.Panel):
    '''This is another panel in the settings notebook. The user adjusts the settings
    for playing the melody and accompanying guitar chords. All of these settings
    are stored in the python dictionary abcsettings.'''
    def __init__(self,parent):
        wx.Panel.__init__(self,parent)
        gridsizer   = wx.FlexGridSizer(20,4,2,2)
        #self.program = ''

        progname = genmidi[int(abcsettings['melprog'])]
        meltxt = wx.StaticText(self,-1,"melody")
        self.melvol = wx.Slider(self,-1,120,0,127,(-1,-1),(128,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS|wx.SL_AUTOTICKS)
        self.melvol.Bind(wx.EVT_SLIDER,self.OnMelVol,self.melvol)
        self.melprog = wx.ComboBox(self,-1,progname,(-1,-1),(200,30),genmidi,wx.CB_DROPDOWN)
        self.melprog.Bind(wx.EVT_COMBOBOX,self.OnMelProgSelection,self.melprog) 

        progname = genmidi[int(abcsettings['doubprog'])]
        self.doubchk = wx.CheckBox(self,-1,"Double",(-1,-1),(80,30))
        self.doubchk.SetValue(str2bool(abcsettings['doubchk']))
        self.doubchk.Bind(wx.EVT_CHECKBOX,self.OnDoubChk,self.doubchk)
        self.doubchk.SetToolTip(wx.ToolTip('Double the melody track as a separate voice'))
        self.doubvol = wx.Slider(self,-1,int(abcsettings['doubvol']),0,127,(-1,-1),(128,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS|wx.SL_AUTOTICKS)
        self.doubvol.Bind(wx.EVT_SLIDER,self.OnDoubVol,self.doubvol)
        self.doubprog = wx.ComboBox(self,-1,progname,(-1,-1),(200,30),genmidi,wx.CB_DROPDOWN)
        self.doubprog.Bind(wx.EVT_COMBOBOX,self.OnDoubProgSelection,self.doubprog) 
        self.douboct = wx.ComboBox(self,-1,abcsettings['douboct'],(-1,-1),(60,30),octaveshift,wx.CB_DROPDOWN)
        self.douboct.Bind(wx.EVT_COMBOBOX,self.OnDoubOctSelection,self.douboct) 
        self.douboct.SetToolTip(wx.ToolTip('Shift up or down by an octave'))

        if abcsettings['doubchk'] == 'False':
            self.doubvol.Disable()
            self.doubprog.Disable()
            self.douboct.Disable()

        progname = genmidi[int(abcsettings['chordprog'])]
        chordtxt = wx.StaticText(self,-1,"chord")
        self.chordvol = wx.Slider(self,-1,int(abcsettings['chordvol']),0,127,(-1,-1),(128,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS|wx.SL_AUTOTICKS)
        self.chordvol.Bind(wx.EVT_SLIDER,self.OnChordVol,self.chordvol)
        self.chordprog = wx.ComboBox(self,-1,progname,(-1,-1),(200,30),genmidi,wx.CB_DROPDOWN)
        self.chordprog.Bind(wx.EVT_COMBOBOX,self.OnChordProgSelection,self.chordprog) 
        self.chordoct = wx.ComboBox(self,-1,abcsettings['chordoct'],(-1,-1),(60,30),octaveshift,wx.CB_DROPDOWN)
        self.chordoct.Bind(wx.EVT_COMBOBOX,self.OnChordOctSelection,self.chordoct) 
        self.chordoct.SetToolTip(wx.ToolTip('Shift up or down by an octave'))

        progname = genmidi[int(abcsettings['bassprog'])]
        basstxt = wx.StaticText(self,-1,"bass")
        self.bassvol = wx.Slider(self,-1,int(abcsettings['bassvol']),0,127,(-1,-1),(128,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS|wx.SL_AUTOTICKS)
        self.bassvol.Bind(wx.EVT_SLIDER,self.OnBassVol,self.bassvol)
        self.bassprog = wx.ComboBox(self,-1,progname,(-1,-1),(200,30),genmidi,wx.CB_DROPDOWN)
        self.bassprog.Bind(wx.EVT_COMBOBOX,self.OnBassProgSelection,self.bassprog) 
        self.bassoct = wx.ComboBox(self,-1,abcsettings['bassoct'],(-1,-1),(60,30),octaveshift,wx.CB_DROPDOWN)
        self.bassoct.Bind(wx.EVT_COMBOBOX,self.OnBassOctSelection,self.bassoct) 
        self.bassoct.SetToolTip(wx.ToolTip('Shift up or down by an octave'))

        gchordtxt = wx.StaticText(self,-1,"gchord pattern")
        self.gchordcombo = wx.ComboBox(self,-1,'default',(-1,-1),(128,-1),[],wx.CB_DROPDOWN)
        gchordchoices = ['default','f','fzfz','gi','gihi','f4c2',
'ghihgh','g2hg2h']
        self.SetGchordChoices(gchordchoices)
        self.gchordcombo.Bind(wx.EVT_COMBOBOX,self.OnGchordSelection,self.gchordcombo) 
        self.gchordcombo.SetToolTip(wx.ToolTip('Not all choices are suitable for this time signature'))
        

        drumtxt = wx.StaticText(self,-1,"drum pattern")
        self.drumcombo = wx.ComboBox(self,-1,'none',(-1,-1),(200,-1),[],wx.CB_DROPDOWN)
        drumchoices = ['none','dd 37 37','dd 76 77','d2ddddd 43 76 77 76 77',
'd2dd2dd 60 60 77 36', 'ddd 63 64 64','d2dd 35 41 41','d2ddd2dd 48 35 48 48 35 48']
        self.SetDrumChoices(drumchoices)
        self.drumcombo.Bind(wx.EVT_COMBOBOX,self.OnDrumSelection,self.drumcombo) 
        self.drumcombo.SetToolTip(wx.ToolTip('Not all choices are suitable for this time signature'))
      

        gridsizer.Add(meltxt,0,0,0)     
        gridsizer.Add(self.melvol,0,0,0)     
        gridsizer.Add(self.melprog,0,0,0)
        gridsizer.Add(wx.Size(-1,-1),0,0,0)

        gridsizer.Add(self.doubchk,0,0,0)     
        gridsizer.Add(self.doubvol,0,0,0)     
        gridsizer.Add(self.doubprog,0,0,0)
        gridsizer.Add(self.douboct,0,0,0)

        gridsizer.Add(chordtxt,0,0,0)     
        gridsizer.Add(self.chordvol,0,0,0)     
        gridsizer.Add(self.chordprog,0,0,0)
        gridsizer.Add(self.chordoct,0,0,0)

        gridsizer.Add(basstxt,0,0,0)     
        gridsizer.Add(self.bassvol,0,0,0)     
        gridsizer.Add(self.bassprog,0,0,0)
        gridsizer.Add(self.bassoct,0,0,0)

        gridsizer.Add(gchordtxt,0,0,0)
        gridsizer.Add(self.gchordcombo,0,0,0)

        #gridsizer.Add(wx.Size(-1,-1),0,0,0)
        #gridsizer.Add(wx.Size(-1,-1),0,0,0)
        gridsizer.Add(self.drumcombo,0,0,0)
        gridsizer.Add(drumtxt,0,0,0)


        gridsizer.Fit(self)
        self.SetSizer(gridsizer)
        self.Fit()
        self.Layout()


    def OnMelProgSelection(self,evt):
        ''' melody program (instrument) assignment'''
        abcsettings['melprog'] =    self.melprog.GetValue()[0:3]

    def OnMelVol(self,evt):
        ''' melody volume (velocity) assignment'''
        abcsettings['melvol'] =     self.melvol.GetValue()

    def OnDoubChk(self,evt):
        ''' switch for doubling the melody voice'''
        abcsettings['doubchk'] =    self.doubchk.GetValue()
        if str2bool(abcsettings['doubchk']) == False:
            self.doubvol.Disable()
            self.doubprog.Disable()
            self.douboct.Disable()
        else:
            self.doubvol.Enable()
            self.doubprog.Enable()
            self.douboct.Enable()

    def OnDoubProgSelection(self,evt):
        ''' doubled melody voice program assignment if applicable'''
        abcsettings['doubprog'] =   self.doubprog.GetValue()[0:3]

    def OnDoubOctSelection(self,evt):
        ''' doubled melody octave shift if applicable '''
        abcsettings['douboct'] =    self.douboct.GetValue()

    def OnDoubVol(self,evt):
        ''' doubled melody volume level if applicable '''
        abcsettings['doubvol'] =    self.doubvol.GetValue()

    def OnChordProgSelection(self,evt):
        ''' chord program assignment '''
        abcsettings['chordprog'] =  self.chordprog.GetValue()[0:3]

    def OnChordOctSelection(self,evt):
        ''' chord octave shift'''
        abcsettings['chordoct'] =   self.chordoct.GetValue()

    def OnChordVol(self,evt):
        ''' chord volume level '''
        abcsettings['chordvol'] =   self.chordvol.GetValue()

    def OnBassProgSelection(self,evt):
        ''' bass program assignment '''
        abcsettings['bassprog'] =   self.bassprog.GetValue()[0:3]

    def OnBassOctSelection(self,evt):
        ''' bass octave shift '''
        abcsettings['bassoct']  =   self.bassoct.GetValue()

    def OnBassVol(self,evt):
        ''' bass volume level '''
        abcsettings['bassvol']  =   self.bassvol.GetValue()

    def SetGchordChoices(self,choices):
        ''' sets the gchord string choices in the gchord combo widget '''
        for item in choices:
            self.gchordcombo.Append(item)

    def SetDrumChoices(self,choices):
        ''' sets the drum string choices in the drum combo widgt '''
        for item in choices:
            self.drumcombo.Append(item)

    def OnGchordSelection(self,evt): 
        ''' saves the gchord string selection '''
        abcsettings['gchord']  =   self.gchordcombo.GetValue()

    def OnDrumSelection(self,evt): 
        ''' saves the drum string selection '''
        abcsettings['drum']  =   self.drumcombo.GetValue()


class MyVoiceSettings(ScrolledPanel):
    def __init__(self,parent):
        ScrolledPanel.__init__(self,parent)
        self.SetSize((500,300))
        self.SetupScrolling()
        vprog = eval(abcsettings['vprog'])
        vvol  = eval(abcsettings['vvol'])
        vbal  = eval(abcsettings['vbal'])
        vlab = {}
        self.vprog = {}
        self.vvol = {}
        self.vbal = {}
        gridsizer   = wx.FlexGridSizer(20,4,2,2)
        for i in range(1,16):
            vlab[i]  = wx.StaticText(self,-1,str(i))
            self.vprog[i] = wx.ComboBox(self,-1,vprog[i],(-1,-1),(200,30),genmidi,wx.CB_DROPDOWN)
            self.vvol[i]  = wx.Slider(self,-1,int(vvol[i]),0,128,(-1,-1),(128,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS)
            self.vbal[i]  = wx.Slider(self,-1,int(vbal[i]),0,128,(-1,-1),(128,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS)

            self.vvol[i].num = i
            self.vbal[i].num = i
            self.vprog[i].num = i
            self.vvol[i].Bind(wx.EVT_SLIDER,self.OnVolSlider,self.vvol[i])
            self.vbal[i].Bind(wx.EVT_SLIDER,self.OnBalSlider,self.vbal[i])
            self.vprog[i].Bind(wx.EVT_COMBOBOX,self.OnProgSel,self.vprog[i])

            gridsizer.Add(vlab[i],0,0,0)     
            gridsizer.Add(self.vprog[i],0,0,0)     
            gridsizer.Add(self.vvol[i],0,0,0)     
            gridsizer.Add(self.vbal[i],0,0,0)     


        gridsizer.Fit(self)
        self.SetSizer(gridsizer)
        self.Fit()
        self.Layout()


    def OnVolSlider(self,evt):
        global abcsettings
        vvol  = eval(abcsettings['vvol'])
        obj = evt.GetEventObject()
        val = obj.GetValue()
        num = obj.num
        vvol[num] = str(val)
        abcsettings['vvol'] = str(vvol)

    def OnBalSlider(self,evt):
        global abcsettings
        vbal  = eval(abcsettings['vbal'])
        obj = evt.GetEventObject()
        val = obj.GetValue()
        num = obj.num
        vbal[num] = str(val)
        abcsettings['vbal'] = str(vbal)

    def OnProgSel(self,evt):
        global abcsettings
        vprog = eval(abcsettings['vprog'])
        obj = evt.GetEventObject()
        val = obj.GetValue()
        num = obj.num
        vprog[num] = str(val)
        abcsettings['vprog'] = str(vprog)


class MyAbc2midiSettings2(wx.Panel):
    ''' Another panel in the Settings notebook. '''
    def __init__(self,parent):
        wx.Panel.__init__(self,parent)
        gridsizer   = wx.GridBagSizer(vgap=8,hgap=8)
        self.NFNP = wx.CheckBox(self,-1,"Ignore dynamic markings",(-1,-1),(200,20))
        self.NFNP.SetValue(str2bool(abcsettings['midi2NFNP']))
        self.NFNP.Bind(wx.EVT_CHECKBOX,self.OnNFNP,self.NFNP)
        self.NFER = wx.CheckBox(self,-1,"Ignore fermatas",(-1,-1),(150,20))
        self.NFER.SetValue(str2bool(abcsettings['midi2NFER']))
        self.NFER.Bind(wx.EVT_CHECKBOX,self.OnNFER,self.NFER)
        self.NGRA = wx.CheckBox(self,-1,"Ignore grace notes",(-1,-1),(150,20))
        self.NGRA.SetValue(str2bool(abcsettings['midi2NGRA']))
        self.NGRA.Bind(wx.EVT_CHECKBOX,self.OnNGRA,self.NGRA)
        self.BF =   wx.CheckBox(self,-1,"Barfly mode",(-1,-1),(150,20))
        self.BF.SetValue(str2bool(abcsettings['midi2BF']))
        self.BF.Bind(wx.EVT_CHECKBOX,self.OnBF,self.BF)
        self.RS =   wx.CheckBox(self,-1,"Broken rhythm 3:1 ratio",(-1,-1),(200,20))
        self.RS.SetValue(str2bool(abcsettings['midi2RS']))
        self.RS.Bind(wx.EVT_CHECKBOX,self.OnRS,self.RS)

        self.tempochk = wx.CheckBox(self,-1,"Override tempo",(-1,-1),(140,30))
        self.tempochk.SetValue(str2bool(abcsettings['ignoreQ']))
        self.tempochk.Bind(wx.EVT_CHECKBOX,self.OnTempoChk,self.tempochk)
        self.tempochk.SetToolTip(wx.ToolTip('Ignore the tempo indicated in the abc file and use the one specified here.'))
        self.midichk = wx.CheckBox(self,-1,"Override %%MIDI settings",(-1,-1),(190,30))
        self.midichk.SetValue(str2bool(abcsettings['ignoreMIDI']))
        self.midichk.Bind(wx.EVT_CHECKBOX,self.OnMidiChk,self.midichk)
        self.midichk.SetToolTip(wx.ToolTip('Ignore the instrument settings indicated in the abc file and use the ones indicated here.'))
        

        tempotxt = wx.StaticText(self,-1,"tempo")
        self.temposlider = wx.Slider(self,-1,int(abcsettings['tempo']),40,296,(-1,-1),(200,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS|wx.SL_AUTOTICKS)
        self.temposlider.Bind(wx.EVT_SLIDER,self.OnTempo,self.temposlider)
        self.temposlider.SetTickFreq(32)

        self.pitch = wx.Slider(self,-1,int(abcsettings['apitch']),416,466,(-1,-1),(200,-1),style=wx.SL_HORIZONTAL|wx.SL_LABELS|wx.SL_AUTOTICKS)
        self.pitch.Bind(wx.EVT_SLIDER,self.OnPitch,self.pitch)
        pitchtxt = wx.StaticText(self,-1,"concert pitch A")
        self.pitch.ClearTicks()
        self.pitch.SetTick(10)
        self.pitch.SetTickFreq(12)

        gridsizer.Add(tempotxt,(1,2))
        gridsizer.Add(self.temposlider,(1,1))
        gridsizer.Add(self.pitch,(2,1))
        gridsizer.Add(pitchtxt,(2,2))
        gridsizer.Add(self.NFNP,(3,1))     
        gridsizer.Add(self.NFER,(3,2))     
        gridsizer.Add(self.NGRA,(4,1))     
        gridsizer.Add(self.BF,(4,2))     
        gridsizer.Add(self.RS,(5,1))
        gridsizer.Add(self.tempochk,(5,2))
        gridsizer.Add(self.midichk,(6,1))

        gridsizer.Fit(self)
        self.SetSizer(gridsizer)
        self.Fit()

    def OnNFNP(self,evt):
        global settings
        abcsettings['midi2NFNP'] = self.NFNP.GetValue()
        update_abc2midipam()
        #settings.abc2midipamtxt.SetValue(abcsettings['abc2midipam'])

    def OnNFER(self,evt):
        global settings
        abcsettings['midi2NFER'] = self.NFER.GetValue()
        update_abc2midipam()
        #settings.abc2midipamtxt.SetValue(abcsettings['abc2midipam'])

    def OnNGRA(self,evt):
        global settings
        abcsettings['midi2NGRA'] = self.NGRA.GetValue()
        update_abc2midipam()
        #settings.abc2midipamtxt.SetValue(abcsettings['abc2midipam'])

    def OnBF(self,evt):
        global settings
        abcsettings['midi2BF'] = self.BF.GetValue()
        update_abc2midipam()
        #settings.abc2midipamtxt.SetValue(abcsettings['abc2midipam'])

    def OnRS(self,evt):
        global settings
        abcsettings['midi2RS'] = self.RS.GetValue()
        update_abc2midipam()
        #settings.abc2midipamtxt.SetValue(abcsettings['abc2midipam'])

    def OnTempo(self,evt):
        abcsettings['tempo']    =   self.temposlider.GetValue()

    def OnPitch(self,evt):
        global settings
        abcsettings['apitch'] = self.pitch.GetValue()
        update_abc2midipam()
        #settings.abc2midipamtxt.SetValue(abcsettings['abc2midipam'])

    def OnTempoChk(self,evt):
        abcsettings['ignoreQ']  =   self.tempochk.GetValue()

    def OnMidiChk(self,evt):
        abcsettings['ignoreMIDI'] = self.midichk.GetValue()



class MyAbcm2psSettings(wx.Panel):
    ''' Another panel in the Settings notebook '''
    def __init__(self,parent):
        wx.Panel.__init__(self,parent)
        box = wx.BoxSizer(wx.VERTICAL)
        gridsizer1   = wx.GridBagSizer(vgap=8,hgap=2)
        gridsizer2   = wx.GridBagSizer(vgap=8,hgap=2)
        box.Add(gridsizer1,0,wx.EXPAND)
        box.Add(gridsizer2,0,wx.EXPAND)
        self.refnum = wx.CheckBox(self,-1,"Reference numb",(-1,-1),(120,20))
        self.refnum.SetValue(str2bool(abcsettings['psrefno']))
        self.refnum.Bind(wx.EVT_CHECKBOX,self.OnRefnumChk,self.refnum)
        self.refnum.SetToolTip(wx.ToolTip('Include the abc X:reference number with the title'))

        self.barnum = wx.CheckBox(self,-1,"Bar numbers",(-1,-1),(120,20))
        self.barnum.SetValue(str2bool(abcsettings['psbarno']))
        self.barnum.Bind(wx.EVT_CHECKBOX,self.OnBarnumChk,self.barnum)
        self.barnum.SetToolTip(wx.ToolTip('Overlay bar numbers over each bar.'))

        self.iglinends = wx.CheckBox(self,-1,"Ignore line ends",(-1,-1),(120,20))
        self.iglinends.SetValue(str2bool(abcsettings['pslines']))
        self.iglinends.Bind(wx.EVT_CHECKBOX,self.OnIglinendsChk,self.iglinends)
        self.iglinends.SetToolTip(wx.ToolTip('Do not necessarily break the staff at the end of a line in the abc representation.'))

        self.nolyrics = wx.CheckBox(self,-1,"No lyrics",(-1,-1),(120,20))
        self.nolyrics.SetValue(str2bool(abcsettings['pslyric']))
        self.nolyrics.Bind(wx.EVT_CHECKBOX,self.OnNolyricsChk,self.nolyrics)
        self.nolyrics.SetToolTip(wx.ToolTip('Do not include the lyrics in the common music notation.'))

        self.flatbeams = wx.CheckBox(self,-1,"Flat Beams",(-1,-1),(120,20))
        self.flatbeams.SetValue(str2bool(abcsettings['psflatb']))
        self.flatbeams.Bind(wx.EVT_CHECKBOX,self.OnFlatbeamsChk,self.flatbeams)
        self.flatbeams.SetToolTip(wx.ToolTip('The beams joining notes are horizontal instead of following the notes position.'))

        self.landscape = wx.CheckBox(self,-1,"Landscape",(-1,-1),(120,20))
        self.landscape.SetValue(str2bool(abcsettings['pslands']))
        self.landscape.Bind(wx.EVT_CHECKBOX,self.OnLandscapeChk,self.landscape)
        self.landscape.SetToolTip(wx.ToolTip('Produce an output ps or svg file for landscape presentation.'))

        self.svg       = wx.CheckBox(self,-1,"Svg output",(-1,-1),(120,20))
        self.svg.SetValue(str2bool(abcsettings['pssvg']))
        self.svg.Bind(wx.EVT_CHECKBOX,self.OnSvgOutputChk,self.svg)
        self.svg.SetToolTip(wx.ToolTip('Instruct abcm2ps to produce a svg file instead of a ps file and call an internet browser to display the svg file.'))

        self.embed = wx.CheckBox(self,-1,"Embed PS in abc",(-1,-1),(120,20))
        self.embed.SetValue(str2bool(abcsettings['psembed']))
        self.embed.Bind(wx.EVT_CHECKBOX,self.OnPsEmbedChk,self.embed)
        self.embed.SetToolTip(wx.ToolTip('Use inline code in the abc file to set abcm2ps options instead of run time parameters.'))


        fval = float(abcsettings['psscale'])
        ival = int(fval*100)
        scalelab  = wx.StaticText(self,-1,"scale factor")
        self.scalevaltxt = wx.StaticText(self,-1,str(fval))
        self.scaleval = wx.Slider(self,-1,ival,40,130,(-1,-1),(192,-1),style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS)
        self.scaleval.Bind(wx.EVT_SLIDER,self.OnPSScale,self.scaleval)
        self.scaleval.SetTickFreq(10,1)
        self.scaleval.SetToolTip(wx.ToolTip('Scales the separation between staff lines. Recommended value 0.80.'))

        widthlab  = wx.StaticText(self,-1,"page width")
        self.widthtxt = wx.StaticText(self,-1,abcsettings['pswidth'])
        self.widthval = wx.Slider(self,-1,int(abcsettings['pswidth']),100,600,(-1,-1),(192,-1),style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS)
        self.widthval.Bind(wx.EVT_SLIDER,self.OnPSwidth,self.widthval)
        self.widthval.SetTickFreq(100,1)
        self.widthval.SetToolTip(wx.ToolTip('72 points per inch, 28.34 points per centimeter. Suggested value 540'))


        lmarglab  = wx.StaticText(self,-1,"left margin")
        self.lmargtxt = wx.StaticText(self,-1,abcsettings['pslmarg'])
        self.lmargval = wx.Slider(self,-1,50,0,200,(-1,-1),(192,-1),style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS)
        self.lmargval.Bind(wx.EVT_SLIDER,self.OnPSlmarg,self.lmargval)
        self.lmargval.SetTickFreq(10,1)
        self.lmargval.SetToolTip(wx.ToolTip('72 points per inch, 28.34 points per centimeter. Suggested value 40'))

        stafflab  = wx.StaticText(self,-1,"staff separation")
        self.stafftxt = wx.StaticText(self,-1,abcsettings['psstaff'])
        self.staffval = wx.Slider(self,-1,20,0,100,(-1,-1),(192,-1),style=wx.SL_HORIZONTAL|wx.SL_AUTOTICKS)
        self.staffval.Bind(wx.EVT_SLIDER,self.OnPSstaff,self.staffval)
        self.staffval.SetToolTip(wx.ToolTip('Minimum staff separtion.  Abcm2ps will automatically adjust the separation so that the notes in the adjacent staffs do not overlap. Suggested value 0.'))
        self.staffval.SetTickFreq(10,1)

        gridsizer1.Add(self.refnum,(1,1))     
        gridsizer1.Add(self.barnum,(1,2))
        gridsizer1.Add(self.iglinends,(1,3))
        gridsizer1.Add(self.nolyrics,(2,1))
        gridsizer1.Add(self.landscape,(2,2))
        gridsizer1.Add(self.flatbeams,(2,3))
        gridsizer1.Add(self.svg,(3,1))
        gridsizer1.Add(self.embed,(3,2))


        gridsizer2.Add(scalelab,(1,1))
        gridsizer2.Add(self.scaleval,(1,2))
        gridsizer2.Add(self.scalevaltxt,(1,3))

        gridsizer2.Add(widthlab,(2,1))
        gridsizer2.Add(self.widthval,(2,2))
        gridsizer2.Add(self.widthtxt,(2,3))

        gridsizer2.Add(lmarglab,(3,1))
        gridsizer2.Add(self.lmargval,(3,2))
        gridsizer2.Add(self.lmargtxt,(3,3))

        gridsizer2.Add(stafflab,(4,1))
        gridsizer2.Add(self.staffval,(4,2))
        gridsizer2.Add(self.stafftxt,(4,3))

        self.SetSizer(box)
        self.Fit()

    def OnRefnumChk(self,evt):
        global settings
        abcsettings['psrefno'] = self.refnum.GetValue()
        update_abcm2pspam()
        #settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnBarnumChk(self,evt):
        global settings
        abcsettings['psbarno'] = self.barnum.GetValue()
        update_abcm2pspam()
        #settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnIglinendsChk(self,evt):
        global settings
        abcsettings['pslines'] = self.iglinends.GetValue()
        update_abcm2pspam()
        #settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnNolyricsChk(self,evt):
        global settings
        abcsettings['pslyric'] = self.nolyrics.GetValue()
        update_abcm2pspam()
        #settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnFlatbeamsChk(self,evt):
        global settings
        abcsettings['psflatb'] = self.flatbeams.GetValue()
        update_abcm2pspam()
        #settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnLandscapeChk(self,evt):
        global settings
        abcsettings['pslands'] = self.flatbeams.GetValue()
        update_abcm2pspam()
        #settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnPsEmbedChk(self,evt):
        global settings
        abcsettings['psembed'] = self.embed.GetValue()

    def OnSvgOutputChk(self,evt):
        global settings
        abcsettings['pssvg'] = self.svg.GetValue()
        update_abcm2pspam()
        #settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnPSScale(self,evt):
        value = self.scaleval.GetValue()
        floatvalue = value/100.0
        self.scalevaltxt.SetLabel(str(floatvalue))
        abcsettings['psscale'] = str(floatvalue)
        update_abcm2pspam()
        settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnPSwidth(self,evt):
        value = self.widthval.GetValue()
        self.widthtxt.SetLabel(str(value))
        abcsettings['pswidth'] = str(value)
        update_abcm2pspam()
        settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnPSlmarg(self,evt):
        value = self.lmargval.GetValue()
        self.lmargtxt.SetLabel(str(value))
        abcsettings['pslmarg'] = str(value)
        update_abcm2pspam()
        settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])

    def OnPSstaff(self,evt):
        value = self.staffval.GetValue()
        self.stafftxt.SetLabel(str(value))
        abcsettings['psstaff'] = str(value)
        update_abcm2pspam()
        settings.abcm2pspamtxt.SetValue(abcsettings['abcm2pspam'])



class MyNoteBook(wx.Frame):
    ''' Settings Notebook '''
    def __init__(self):
        wx.Frame.__init__(self, wx.GetApp().TopWindow, wx.ID_ANY, "Abc Settings",style=wx.DEFAULT_FRAME_STYLE,name='settingsbook')
        # Add a panel so it looks the correct on all platforms
        p = wx.Panel(self)
        nb = wx.Notebook(p)
        global settings
        settings = self
        midisettings = MyAbc2midiSettings(nb)
        midisettings2 = MyAbc2midiSettings2(nb)
        abcm2pssettings = MyAbcm2psSettings(nb)
        self.filesettings = MyFileSettings(nb)
        voicesettings = MyVoiceSettings(nb)
        nb.AddPage(self.filesettings,"File Settings")
        nb.AddPage(midisettings,"Midi 1")
        nb.AddPage(midisettings2,"Midi 2")
        nb.AddPage(voicesettings,"Voices")
        nb.AddPage(abcm2pssettings,"Abcm2ps")

        sizer = wx.BoxSizer()
        sizer.Add(nb,1,wx.ALL|wx.EXPAND)
        p.SetSizer(sizer)
        sizer.Fit(self)



class MyTextPanel(wx.Panel):
    ''' Creates the SytledTextCtrl for displaying the abc notation
    of the selected tune. Line numbering is displayed on the left
    to match the line numbers of the error and warning messages
    that may be issued by abcm2ps or abc2midi. '''
    def __init__(self,parent):
        wx.Panel.__init__(self,parent,id=wx.ID_ANY,size=(520,320))
        self.basicText = stc.StyledTextCtrl(self,-1,(-1,-1),(700,320))
        self.basicText.SetMarginLeft(25)
        self.basicText.SetMarginType(1,stc.STC_MARGIN_NUMBER)


    def ShowText(self,text):
        ''' Replaces the contents with given text. '''
        #print text
        self.basicText.ClearAll()
        self.basicText.AppendText(text)




class MyInfoFrame(wx.Frame):
    ''' Creates the TextCtrl for displaying any messages from abc2midi or
    abcm2ps. '''
    def __init__(self):
        wx.Frame.__init__(self, wx.GetApp().TopWindow, wx.ID_ANY, "Messages",style=wx.DEFAULT_FRAME_STYLE,name='infoframe')
        # Add a panel so it looks the correct on all platforms
        panel = ScrolledPanel(self)
        panel.SetupScrolling()
        self.basicText = wx.TextCtrl(self,-1,"",size=(400,160),style=wx.TE_MULTILINE | wx.TE_READONLY)
        sizer = wx.BoxSizer()
        sizer.Add(self.basicText,1,wx.ALL|wx.EXPAND)
        self.basicText.SetSizer(sizer)
        sizer.Fit(self)

    def ShowText(self,text):
        self.basicText.Clear()
        self.basicText.AppendText(text)



class MySearchFrame(wx.Frame):
    ''' For searching a directory of abc files for tunes containing 
    a string. '''
    def __init__(self):
        wx.Frame.__init__(self, wx.GetApp().TopWindow, wx.ID_ANY, "Search files",style=wx.DEFAULT_FRAME_STYLE,name='searcher')
        # Add a panel so it looks the correct on all platforms
        wx.Frame.SetDimensions(self,-1,-1,380,360)
        self.searchdata = ''
        searchfold = wx.StaticText(self,-1,"Folder")
        self.searchfoldtxt = wx.TextCtrl(self,-1,abcsettings['searchfolder'],(-1,-1),(200,-1))
        self.browsebut = wx.Button(self,-1,'Browse')
        searchlab = wx.StaticText(self,-1,'String')
        self.searchstring = wx.TextCtrl(self,-1,self.searchdata,(-1,-1),(200,-1))
        self.startbut = wx.Button(self,-1,'Search')
        self.list_ctrl = wx.ListCtrl(self, size=(360,520),
                         style=wx.LC_REPORT |wx.BORDER_SUNKEN|wx.LC_SINGLE_SEL)
        self.list_ctrl.InsertColumn(0, 'Title', width=400)

        self.running = 0
        self.searchlocator = {}
        self.searchpaths = {}
        self.count = 0


        mainsizer = wx.BoxSizer(wx.VERTICAL)
        sizer1   = wx.GridBagSizer(vgap=8,hgap=8)
        sizer2   = wx.BoxSizer(wx.VERTICAL)
        sizer1.Add(searchfold,(1,1))
        sizer1.Add(self.searchfoldtxt,(1,2))
        sizer1.Add(self.browsebut,(1,3))
        sizer1.Add(searchlab,(2,1))
        sizer1.Add(self.searchstring,(2,2))
        sizer1.Add(self.startbut,(2,3))
        sizer2.Add(self.list_ctrl,0,wx.ALL|wx.EXPAND)
        mainsizer.Add(sizer1,0,wx.ALL|wx.EXPAND)
        mainsizer.Add(sizer2,1,wx.ALL|wx.EXPAND)
        mainsizer.SetMinSize((360,200))
        self.SetSizer(mainsizer)
        self.Show()

        self.Bind(wx.EVT_BUTTON,self.On_browse_abcsearch,self.browsebut)
        self.Bind(wx.EVT_BUTTON,self.On_start_search,self.startbut)
        self.list_ctrl.Bind(wx.EVT_LIST_ITEM_SELECTED,self.OnItemSelected,self.list_ctrl)


    def On_browse_abcsearch(self,evt):
        ''' Selects the folder to open for searching'''
        dlg = wx.DirDialog(self,"Open","Choose a folder",wx.OPEN)
        if dlg.ShowModal() == wx.ID_OK:
           abcsettings['searchfolder']    =  dlg.GetPath()
           self.searchfoldtxt.SetValue(abcsettings['searchfolder'])
        dlg.Destroy()


    def On_start_search(self,evt):
        ''' Initializes dictionaries and calls find_abc_files'''
        self.list_ctrl.DeleteAllItems()
        self.searchlocator = {}
        self.searchpaths = {}
        self.count = 0
        find_abc_files(abcsettings['searchfolder'])
        

    def OnItemSelected(self,evt):
        ''' Responds to a selected title in the search listbox results. The abc file
        containing the selected tune is opened and the table of contents is updated.'''
        global abcindex
        index = evt.GetIndex()
        path = self.searchpaths[index]
        loc = self.searchlocator[index]
        abcsettings['openfile'] = path
        abcindex = toc(path)
        top.list_ctrl.add_toc_database(abcindex)
        top.list_ctrl.list_ctrl.Focus(loc)
        top.list_ctrl.list_ctrl.Select(loc,1)
        top.UpdateStatusBar(path)



class MyHtmlFrame(wx.Frame):
    ''' Creates an html window for displaying the help info. '''
    def __init__(self):
        wx.Frame.__init__(self, wx.GetApp().TopWindow,-1, title = 'Help Window'         ,name='htmlframe')

        # Add a panel so it looks the correct on all platforms
        global overview
        html = wx.html.HtmlWindow(self)
        if "gtk2" in wx.PlatformInfo:
            html.SetStandardFonts()
        html.SetPage(overview)
       

class MyOpenPopupMenu(wx.Menu):
    ''' menu which opens when you right click on the Open button'''
    def __init__(self):
        wx.Menu.__init__(self)
        item = wx.MenuItem(self,-1,"Open abc file")
        self.AppendItem(item)
        self.Bind(wx.EVT_MENU,self.OnOpenPop,item)

        item = wx.MenuItem(self,-1,"Save edit window")
        self.AppendItem(item)
        self.Bind(wx.EVT_MENU,self.OnSaveEdit,item)

        item = wx.MenuItem(self,-1,"Refresh source file")
        self.AppendItem(item)
        self.Bind(wx.EVT_MENU,self.OnSourceRefresh,item)

    def OnOpenPop(self,event):
        ''' Pop up the Open menu when the button is right clicked.'''
        global top
        top.OnOpen(event)


    def OnSaveEdit(self,event):
        ''' Saves the contents of the edit window to a file selected by
        the user.
        '''
        global top
        stcabc = abcedit.basicText.GetText()
        dlgsave = wx.FileDialog(top,"Save","","","Abc files (*.abc)|*.abc",wx.SAVE)
        if dlgsave.ShowModal() == wx.ID_OK:
            path = dlgsave.GetPath()
            write_abc_file(path,stcabc)
            msg = 'saving '+path
            top.UpdateStatusBar(msg)


    def OnSourceRefresh(self,event):
        '''Replaces the selected tune in the source file with the contents of the
        edit window and writes it to the original source file. A backup of the
        the source file is created.
        '''
        global top
        stcabc = abcedit.basicText.GetText()
        update_source_abc_file (stcabc)
        top.UpdateStatusBar('Updated')


class MyToolsPopupMenu(wx.Menu):
    ''' menu when you click on the Tools button'''
    global top
    def __init__(self):
        wx.Menu.__init__(self)
        item = wx.MenuItem(self,-1,"Search")
        self.AppendItem(item)
        self.Bind(wx.EVT_MENU,top.OnSearch,item)

        item = wx.MenuItem(self,-1,"Remove all MIDI commands")
        self.AppendItem(item)
        self.Bind(wx.EVT_MENU,self.OnMidiRemove,item)

        item = wx.MenuItem(self,-1,"Remove all ps commands")
        self.AppendItem(item)
        self.Bind(wx.EVT_MENU,self.OnPSRemove,item)

        #item = wx.MenuItem(self,-1,"Transpose")
        #self.AppendItem(item)
        #self.Bind(wx.EVT_MENU,self.OnTranspose,item)

        item = wx.MenuItem(self,-1,"Gchords to voice")
        self.AppendItem(item)
        self.Bind(wx.EVT_MENU,self.OnG2V,item)

        #item = wx.MenuItem(self,-1,"Reformat")
        #self.AppendItem(item)
        #self.Bind(wx.EVT_MENU,self.OnTranspose,item)

        #item = wx.MenuItem(self,-1,"Add gchords")
        #self.AppendItem(item)
        #self.Bind(wx.EVT_MENU,self.OnTranspose,item)

        #item = wx.MenuItem(self,-1,"Remove gchords")
        #self.AppendItem(item)
        #self.Bind(wx.EVT_MENU,self.OnTranspose,item)

        #item = wx.MenuItem(self,-1,"Add grace notes")
        #self.AppendItem(item)
        #self.Bind(wx.EVT_MENU,self.OnTranspose,item)

        #item = wx.MenuItem(self,-1,"Remove notes")
        #self.AppendItem(item)
        #self.Bind(wx.EVT_MENU,self.OnTranspose,item)


    def OnMidiRemove(self,event):
        ''' For removing all %%MIDI commands in the edit window '''
        global abc
        try:
            abc
            abc = remove_all_MIDI_commands(abc)
            abcedit.ShowText(abc)
        except NameError:
            top.UpdateStatusBar("no tune selected")
        

    def OnPSRemove(self,event):
        ''' For removing all lines starting with %%.'''
        global abc
        try:
            abc
            abc = remove_all_ps_commands(abc)
            abcedit.ShowText(abc)
        except NameError:
            top.UpdateStatusBar("no tune selected")


    def OnG2V(self,event):
        ''' For removing all lines starting with %%.'''
        global abc
        try:
            abc 
            stcabc = g2v.gchord2voice.g2v(abc)
            abcedit.ShowText(stcabc)
        except NameError:
            top.UpdateStatusBar("no tune selected")

    def OnTranspose(self,event):
        global top
        print "not implemented yet"

class MyMain(wx.Frame):
    #----------------------------------------------------------------------
    def __init__(self):
        wx.Frame.__init__(self, None, wx.ID_ANY, "Abc File TOC",style=wx.DEFAULT_FRAME_STYLE)
        # Add a panel so it looks the correct on all platforms
        global abcsettings
        global abcindex 
        global path
        global abcedit

        wx.Frame.SetDimensions(self,-1,-1,880,380)
        #panel = wx.Panel(self, wx.ID_ANY)
        self.index = 0
        self.statusbar = self.CreateStatusBar()

        self.openbut = wx.Button(self,-1,'Open')
        playbut = wx.Button(self,-1,'Play')
        playbut.SetToolTip(wx.ToolTip('Right click will play just the contents of the edit pane.'))
        displaybut = wx.Button(self,-1,'Display')
        displaybut.SetToolTip(wx.ToolTip('Right click will display just the contents of the edit pane.'))
        messagesbut = wx.Button(self,-1,'Messages')
        settingsbut = wx.Button(self,-1,'Settings')
        toolsbut     = wx.Button(self,-1,'Tools')
        exitbut = wx.Button(self,-1,'Exit')
        helpbut = wx.Button(self,-1,'Help')

        self.openbut.Bind(wx.EVT_BUTTON,self.OnOpen,self.openbut)
        self.openbut.Bind(wx.EVT_RIGHT_DOWN,self.OnRightOpen,self.openbut)
        playbut.Bind(wx.EVT_BUTTON,self.OnPlay,playbut)
        playbut.Bind(wx.EVT_RIGHT_DOWN,self.OnRightPlay,playbut)
        displaybut.Bind(wx.EVT_BUTTON,self.OnDisplay,displaybut)
        displaybut.Bind(wx.EVT_RIGHT_DOWN,self.OnRightDisplay,displaybut)
        messagesbut.Bind(wx.EVT_BUTTON,self.OnMessages,messagesbut)
        toolsbut.Bind(wx.EVT_BUTTON,self.OnToolsMenu,toolsbut)
        exitbut.Bind(wx.EVT_BUTTON,self.OnExit,exitbut)
        helpbut.Bind(wx.EVT_BUTTON,self.OnHelp,helpbut)
        settingsbut.Bind(wx.EVT_BUTTON,self.OnNoteBook,settingsbut)


        self.list_ctrl = MyToc(self)
        abcedit = MyTextPanel(self)

        sizer = wx.BoxSizer(wx.VERTICAL)
        buttonsizer =wx.BoxSizer(wx.HORIZONTAL)
        funcsizer = wx.BoxSizer(wx.HORIZONTAL)
        sizer.Add(buttonsizer,0,wx.ALL|wx.EXPAND)
        sizer.Add(funcsizer,0,wx.ALL|wx.EXPAND)

        buttonsizer.Add(self.openbut,0,wx.ALL|wx.EXPAND,2)
        buttonsizer.Add(playbut,0,wx.ALL|wx.EXPAND,2)
        buttonsizer.Add(displaybut,0,wx.ALL|wx.EXPAND,2)
        buttonsizer.Add(messagesbut,0,wx.ALL|wx.EXPAND,2)
        buttonsizer.Add(settingsbut,0,wx.ALL|wx.EXPAND,2)
        buttonsizer.Add(toolsbut,0,wx.ALL|wx.EXPAND,2)
        buttonsizer.Add(helpbut,0,wx.ALL|wx.EXPAND,2)
        buttonsizer.Add(exitbut,0,wx.ALL|wx.EXPAND,2)

        funcsizer.Add(self.list_ctrl,1,wx.ALL|wx.EXPAND)
        funcsizer.Add(abcedit,2,wx.ALL|wx.EXPAND)

        self.SetSizerAndFit(sizer)
        self.Show()

        path = abcsettings['openfile']
        if path != None and os.path.exists(path) == True:
           abcindex = toc(path)
           self.list_ctrl.add_toc_database(abcindex)
           self.UpdateStatusBar(path)


    def UpdateStatusBar(self,text):
        self.statusbar.SetStatusText(text)
        #print text


    def OnOpen(self, evt):
        global abcindex
        global path
        dlg = wx.FileDialog(self,"Open","","","Abc files (*.abc)|*.abc",wx.OPEN)
        if dlg.ShowModal() == wx.ID_OK:
           path = dlg.GetPath()
           abcsettings['openfile'] = path
           abcindex = toc(path)
           self.list_ctrl.add_toc_database(abcindex)
        dlg.Destroy()


    def OnRightOpen(self,evt):
        menu = MyOpenPopupMenu()
        self.PopupMenu(menu)
        menu.Destroy()

    def OnToolsMenu(self,evt):
        menu = MyToolsPopupMenu()
        self.PopupMenu(menu)
        menu.Destroy()


    def OnExit(self,evt):
        self.Close()


    def OnPlay(self,evt):
        self.UpdateStatusBar("Play Selected")
        try:
            abc
        except NameError:
            dlg = wx.MessageDialog(self,'You need to select a tune first','Warning',wx.OK)
            dlg.ShowModal()
            self.UpdateStatusBar("No tune was selected")
            return
        else:
            create_tmp_for_abc2midi (abc)
            run_abc2midi(self)
            start_midi_out()



    def OnRightPlay(self,evt):
        stcabc = abcedit.basicText.GetText()
        #print stcabc
        write_abc_file('X.tmp',stcabc)
        run_abc2midi(self)
        start_midi_out()



    def OnDisplay(self,evt):
        self.UpdateStatusBar("Display Selected")
        try:
            abc
        except NameError:
            dlg = wx.MessageDialog(self,'You need to select a tune first','Warning',wx.OK)
            dlg.ShowModal()
            self.UpdateStatusBar("No tune was selected")
            return
        else:
            create_tmp_for_abcm2ps (abc)
            run_abcm2ps(self)
            start_display_out(self)


    def OnRightDisplay(self,evt):
            stcabc = abcedit.basicText.GetText()
            write_abc_file('X.tmp',stcabc)
            run_abcm2ps(self)
            start_display_out(self)



    def OnMessages(self,evt):
        global outputmsg
        #do not make infobox if already present
        win = wx.FindWindowByName('infoframe')
        if win == None:
            self.msg = MyInfoFrame()
            self.msg.ShowText(outputmsg)
            self.msg.Show() 
        else:
            self.msg.ShowText(outputmsg)


    def OnHelp(self,evt):
        #do not make htmlframe if already present
        win = wx.FindWindowByName('htmlframe')
        if win == None:
            self.help = MyHtmlFrame()
            self.help.Show()




    def OnNoteBook(self,evt):
        #do not make another notebook if already present
        win = wx.FindWindowByName('settingsbook')
        if win != None:
            return
        self.book = MyNoteBook()
        self.book.Show() 


    def OnSearch(self,event):
        win = wx.FindWindowByName('searcher')
        if win != None:
            return
        self.search = MySearchFrame()
        self.search.Show()

        
class App(wx.App):
    def OnInit(self):
        global top
        top = self.frame = MyMain()
        self.frame.Show()
        return True
    
overview = '''
<html><body>
<h2><center>abccore</center></h2>

Updated 2014-11-04.

This application was developed to complement EasyAbc. It is
basically a user interface for the abc2midi and abcm2ps programs.
There is not much of an editor here, but it contains other features that are
missing from EasyAbc. The purpose of the program was to investigate
new features that may eventually be incorporated into EasyAbc.
<p>
The first time you run the program, it will create a folder
called abccore_home in your home folder on your system. This
folder contains the abccore.ini where it stores your preferences
and some temporary files needed to display and play files.
When you run the program for the first time, you will need to
go to the Settings item and specify the paths to the executables,
in particular abc2midi and abcm2ps. PS_renderer in the file settings
refers to a program like ghostscript which displays a PostScript
file.
<p>
Next, you click on the <b>Open</b> button and find and open an abc file
containing a collection of tunes. The program will display the
the list of titles in a listbox on the left. When you click on
a title, the contents of that tune will displayed on the right
side. Clicking on the <b>Play</b> will cause this program to generate
a MIDI file and play it using the player designated in the
settings window. The temporary abc file that was used to create
the abc file will update the right window. You can view any
messages that abc2midi produced by clicking on the <b>Messages</b>
button. At any time, if you right click on the <b>Play</b> button,
then the program will just play the contents of the edit window
exactly as written. (The contents will be saved in a file called
X.tmp.) If you edit the contents of the edit window, you can save
the results by right clicking the <b>Open</b> button and a menu
will pop up. If you refresh the original source file, a backup
file with a <b>bak</b> extension will be created.
<p>
 The <b>Display</b> button shows the sheet music and works in
a similar fashion. Normally abcm2ps produces a PostScript file
and you require a program like GhostScript which is capable of
displaying this file. However, abcm2ps can also produce a SVG
(Scaleable Vector Graphics) file and almost any internet browser
is capable of displaying it. If you set the SVG checkbox in
the <b>Settings/abcm2ps</b> page, the program will request
SVG output and present it using an internet browser that you
specify in the top Settings page. There are many other abcm2ps
settings that you can customize. If you hover the mouse pointer
over one of the checkboxes, a balloon help will appear with
some explanation.
<p>
The tool button brings up a menu of additional functions. The
<b>Search</b> tool will search inside a folder and all subfolders
for abc tunes containing a certain string in the title field.
The titles of all the tunes found will be displayed in a listbox.
Clicking on one of the tunes, will open that file and tune.
<b>Gchords to voice</b> will put all the guitar chords into
a separate voice. The guitar chords will be expanded into 
their notes based on the gchord string.
<p>
Abccore stores all the user's settings including the path
of the last open abc file in a file called abccore.ini. In
event that the file abccore.ini is corrupted or abccore does
not start properly, it may be necessary to do a reset by
deleting the abccore.ini file.
<p>
Most of the interesting features are hidden in the <b>Settings</b>
notebook.

<p> The program was developed by Seymour.Shlien@crc.ca
</body></html>
'''

 
#----------------------------------------------------------------------
# Run the program
if __name__ == "__main__":


    app_dir = expanduser("~")
    app_dir = os.path.join(app_dir,'abccore_home')
    if not os.path.exists(app_dir):
        os.mkdir(app_dir)
    os.chdir(app_dir)

    initialize_settings()
    abcsettingskeys = abcsettings.keys()
    try:
       load_settings(abcsettingskeys)
    except:
       pass

    app = App()

    #import wx.lib.inspection
    #wx.lib.inspection.InspectionTool().Show()

    app.MainLoop()
    save_settings()

