#gcstring.py

'''
The %%MIDI gchord 'string' specifies how the
accompaniment is created (see details in abcmidi/doc/abcguide.txt)
'''


import re
import gchord

gcspat =re.compile('[zcfbghijGHIJ]\d*')
gcsep  =re.compile('([zcfbghijGHIJ])(\d*)')
gcstrlist = []
gc_string_length = 0

def initialize_gcstring():
    global gcstringlist
    global gc_string_length
    global gchordoutput
    gcstrlist = []
    gc_string_length = 0
    gchordoutput = []


def process_gchord_cmd(cmd):
  # process a %%MIDI gchord command
  cmdlist = cmd.split()
  scangchordstring(cmdlist[1])

def scangchordstring(gc):
# create gctrlist from gchord string gc
# and determine its length (gc_string_length)
  global gcstrlist
  global gc_string_length
  gc_string_length = 0
  gcstrlist  =  gcspat.findall(gc)
  for elem in gcstrlist:
     m = gcsep.match(elem)
     if m.groups():
        m2 = m.groups()[1]
        if m2=='': m2=1
        gc_string_length = gc_string_length + int(m2)





def interpret_gcstringlist():
  '''
  The function create a sequence of notes and
  chords for a bar based on the gchord string and the
  guitar chord. This sequence is stored in the list
  gchordoutput which is used by gchord_generator (see gcgen.py).
  '''
  global gchordoutput
  gchordoutput = []
  for gcmd in gcstrlist:
     m = gcsep.match(gcmd)
     g = m.groups()[0]
     n = m.groups()[1]
    
     if g=='z':
        gchordoutput.append(gcmd)
     elif g=='c':
        out = '['
        for note in gchord.gchordnotes:
           out = out+note
        out = out+']'
        if n != '1':
           out = out+n
        gchordoutput.append(out)
     elif g == 'f':
        gchordoutput.append(gchord.bassnote+n)
     elif g == 'b':
        out = '['+gchord.bassnote
        for note in gchord.gchordnotes:
           out = out+note
        out = out+']'
        out = out+n
        gchordoutput.append(out)
     elif g == 'g':
        note = gchord.gchordnotes[0]
        gchordoutput.append(note+n)
     elif g == 'h':
        note = gchord.gchordnotes[1]
        gchordoutput.append(note+n)
     elif g == 'i':
        note = gchord.gchordnotes[2]
        gchordoutput.append(note+n)
     elif g == 'j':
        note = gchord.gchordnotes[3]
        gchordoutput.append(note+n)
     elif g == 'G':
        note = gchord.gchordnotes[0]+','
        gchordoutput.append(note+n)
     elif g == 'H':
        note = gchord.gchordnotes[1]+','
        gchordoutput.append(note+n)
     elif g == 'I':
        note = gchord.gchordnotes[2]+','
        gchordoutput.append(note+n)
     elif g == 'J':
        note = gchord.gchordnotes[3]+','
        gchordoutput.append(note+n)
     else:
        print('do not recognize ',g)


